Package csb :: Package bio :: Package io :: Module fasta :: Class StructureAlignmentFactory

[frames] | no frames]

# Class StructureAlignmentFactory

source code

    object --+
             |
            StructureAlignmentFactory

Protein structure alignment parser.

In order to construct the structural alignment, this factory needs a PDB structure provider: an object, whose `provider.get` method returns a csb.bio.structute.Structure for a given sequence identifier. Sequence identifiers on the other hand need to be split into 'accession number' and 'chain ID'. By default this is done using a standard PDB Entry ID factory, but clients are free to provide custom factories. An `id_factory` must be a callable, which accepts a single string identifier and returns an EntryID object.

Instance Methods

__init__(self, provider, id_factory=None, strict=True) x.__init__(...) initializes x; see help(type(x)) for signature | source code

SequenceAlignment

make_alignment(self, string) Build a protein structure alignment given a multi-FASTA string and the current structure `provider`. | source code

ChainSequence

make_entry(self, row, chain) Build a protein structure alignment entry, given a sequence alignment entry and its corresponding source PDB chain. | source code

Inherited from `object`: `__delattr__`, `__format__`, `__getattribute__`, `__hash__`, `__new__`, `__reduce__`, `__reduce_ex__`, `__repr__`, `__setattr__`, `__sizeof__`, `__str__`, `__subclasshook__`

Properties
EntryID | id_factory Current csb.bio.io.wwpdb.EntryID factory instance in use
enum item | product_type Default sequence type of the alignment rows - a member of SequenceTypes
StructureProvider | provider Current csb.bio.io.wwpdb.StructureProvider instance in use
bool | strict True if strict mode is enabled
Inherited from `object`: `__class__`

Method Details

### __init__(self, provider, id_factory=None, strict=True)
(Constructor)

source code

x.__init__(...) initializes x; see help(type(x)) for signature

Parameters:
  - `provider` (csb.bio.io.wwpdb.StructureProvider) - data source for all structures found in the alignment
  - `id_factory` (callable) - callable factory, which transforms a sequence ID into a csb.bio.io.wwpdb.EntryID object. By default this is csb.bio.io.wwpdb.EntryID.create.
  - `strict` (bool) - if True, raise exception on duplicate sequence identifiers. See csb.bio.sequence.AbstractAlignment for details
Overrides: object.__init__
  (inherited documentation)

### make_alignment(self, string)

source code

Build a protein structure alignment given a multi-FASTA string and the current structure `provider`.

Parameters:
  - `string` (str) - alignment string
Returns: SequenceAlignment
Raises:
  - `SequenceError` - when an aligned sequence is not a proper subsequence of its respective source PDB chain
  - `StructureNotFoundError` - if `provider` can't provide a structure for a given sequence ID
  - `InvalidEntryIDError` - if a given sequence ID cannot be parsed

### make_entry(self, row, chain)

source code

Build a protein structure alignment entry, given a sequence alignment entry and its corresponding source PDB chain.

Parameters:
  - `row` (AbstractSequence, SequenceAdapter) - sequence alignment entry (sequence with gaps)
  - `chain` (csb.bio.structure.Chain) - source PDB chain
Returns: ChainSequence
  gapped chain sequence, containing cloned residues from the source chain (except for the gaps)
Raises:
  - `SequenceError` - when `row` is not a proper subsequence of `chain`

Property Details

### id_factory

Current csb.bio.io.wwpdb.EntryID factory instance in use

Get Method:
  unreachable.id_factory(self) - Current csb.bio.io.wwpdb.EntryID factory instance in use
Type:
  EntryID

### product_type

Default sequence type of the alignment rows - a member of SequenceTypes

Get Method:
  unreachable.product_type(self) - Default sequence type of the alignment rows - a member of SequenceTypes
Type:
  enum item

### provider

Current csb.bio.io.wwpdb.StructureProvider instance in use

Get Method:
  unreachable.provider(self) - Current csb.bio.io.wwpdb.StructureProvider instance in use
Type:
  StructureProvider

### strict

True if strict mode is enabled

Get Method:
  unreachable.strict(self) - True if strict mode is enabled
Type:
  bool